function [xpxi,xpxixp]=invxpx(x)
 
// PURPOSE: provide inversion of the matrix (x'x) using the
// QR decomposition
// ------------------------------------------------------------
// INPUT:
// x = a (n x k) real matrix
// ------------------------------------------------------------
// OUTPUT:
// * xpxi = the (k x k) matrix equal to inv(x'x)
// * xpxixp = the (k x T) matrix equal to inv(x'x)*x'
// ------------------------------------------------------------
// NOTES:
// used by the following functions:
// ols0(), ols1(), ols2()
// ------------------------------------------------------------
// Copyright: Eric Dubois 2004-2015
// http://dubois.ensae.net/grocer.html

[n,k]=size(x) 
[q,r]= qr(x,'e')
ir=r\eye(k,k)
xpxixp=ir*q'
xpxi=xpxixp*xpxixp'

endfunction
